# FORCE

**Framework for Operational Radiometric Correction for Environmental monitoring**

**Version 3.7.9**

![FORCE Logo](/images/force.png)


## About

**FORCE** is an all-in-one processing engine for medium-resolution Earth Observation image archives. FORCE uses the data cube concept to mass-generate Analysis Ready Data, and enables large area + time series applications. With FORCE, you can perform all essential tasks in a typical Earth Observation Analysis workflow, i.e. going from data to information.

FORCE natively supports the integrated processing and analysis of

* Landsat 4/5 TM,
* Landsat 7 ETM+,
* Landsat 8 OLI,
* Landsat 9 OLI, and
* Sentinel-2 A/B MSI.

Non-native data sources can also be processed, e.g. Sentinel-1 SAR data or environmental variables.


## Related Links

**The documentation** is available on [**Read***the***Docs**](https://force-eo.readthedocs.io/).

**Learn how to use FORCE**. Have a look at the [Tutorials](https://force-eo.readthedocs.io/en/latest/howto/index.html). Check regularly for new content.

**Get help**, and help others in the FORCE [discussion section](https://github.com/davidfrantz/force/discussions)

**Follow** the FORCE project at [ResearchGate](https://www.researchgate.net/project/FORCE-Framework-for-Operational-Radiometric-Correction-for-Environmental-monitoring)

**Stay updated**, and follow me on [Twitter](https://twitter.com/d__frantz)

**You are using FORCE? Spread the word**, and use the [#FORCE_EO](https://twitter.com/search?q=%23FORCE_EO&src=recent_search_click) hashtag in your tweets!

